// Copyright (C) 2023 WYATT GROUP
// Please see the AUTHORS file for details.
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.

import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
import 'package:wyatt_component_copy_with_extension/component_copy_with_extension.dart';
import 'package:wyatt_ui_components/src/domain/entities/bars/top_bar_component.dart';
import 'package:wyatt_ui_components/wyatt_wyatt_ui_components.dart';

part 'top_navigation_bar_component.g.dart';

@ComponentProxyExtension()
abstract class TopNavigationBarComponent extends TopBarComponent
    with CopyWithMixin<$TopNavigationBarComponentCWProxy> {
  const TopNavigationBarComponent({
    this.navigationItems,
    this.onTap,
    this.currentIndex = 0,
    super.shape,
    super.systemOverlayStyle,
    super.automaticallyImplyLeading,
    super.flexibleSpace,
    super.bottom,
    super.elevation,
    super.scrolledUnderElevation,
    super.shadowColor,
    super.surfaceTintColor,
    super.backgroundColor,
    super.iconTheme,
    super.primary,
    super.excludeHeaderSemantics,
    super.toolbarHeight,
    super.leadingWidth,
    super.leading,
    super.actions,
    super.expandedWidget,
    super.key,
  });

  final List<TextWrapper>? navigationItems;
  final int currentIndex;
  final void Function(BuildContext, int)? onTap;
}
