// Copyright (C) 2023 WYATT GROUP
// Please see the AUTHORS file for details.
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.

import 'package:flutter/widgets.dart';
import 'package:wyatt_component_copy_with_extension/component_copy_with_extension.dart';
import 'package:wyatt_ui_components/wyatt_wyatt_ui_components.dart';

part 'loader_component.g.dart';

@ComponentProxyExtension()
abstract class LoaderComponent extends Component
    with CopyWithMixin<$LoaderComponentCWProxy> {
  const LoaderComponent({
    this.colors,
    this.radius,
    this.stroke,
    this.duration,
    this.flip,
    super.themeResolver,
    super.key,
  });

  /// Gradient colors from start to end.
  final MultiColor? colors;

  /// Loader radius
  final double? radius;

  /// Loader stroke width
  final double? stroke;

  /// Animation duration
  final Duration? duration;
  
  /// Flip the animation
  final bool? flip;
}
